// This is called BEFORE your Elm app starts up
// 
// The value returned here will be passed as flags 
// into your `Shared.init` function.
export const flags = ({ env }) => {
    // Log the environment parameter
    console.log('Environment:', env);
  
    // Log the window's inner height and width
    console.log('Window Height:', window.innerHeight);
    console.log('Window Width:', window.innerWidth);
  
    // Determine the device type based on the user agent
    const userAgent = navigator.userAgent.toLowerCase();
    let deviceType = 'Unknown Device';
  
    if (/mobile|android|iphone|ipad|ipod|windows phone/i.test(userAgent)) {
      deviceType = 'Mobile Device';
    } else if (/tablet|ipad/i.test(userAgent)) {
      deviceType = 'Tablet';
    } else if (/desktop|laptop|windows|mac|linux/i.test(userAgent)) {
      deviceType = 'Desktop or Laptop';
    }
  
    // Log the detected device type
    console.log('Device Type:', deviceType);
  
    return {
      height: window.innerHeight,
      width: window.innerWidth
    };
  };
  

// This is called AFTER your Elm app starts up
//
// Here you can work with `app.ports` to send messages
// to your Elm application, or subscribe to incoming
// messages from Elm
export const onReady = ({ app, env }) => {
    app.ports.getArgHeight.subscribe((numArgs) => {
        const heights = [];

        for (let i = 0; i < numArgs; i++) {
            const element = document.getElementById(`arg${i}`);

            if (element) {
                heights.push(element.offsetHeight);
            } else {
                console.error(`Element with ID 'arg${i}' not found.`);
                heights.push(null); // Add null or any placeholder for missing elements
            }
        }
        
        app.ports.gotArgHeight.send(heights);
    });z
};
